#clear all the memory
rm (list=ls())

#load the various sheets of the workbook
library(xlsReadWrite)
setwd("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/idt-spad")
pima.train <- read.xls(file="pima-arbre-spad.xls",colNames=T,sheet="apprentissage")
pima.unlabeled <- read.xls(file="pima-arbre-spad.xls",colNames=T,sheet="a_classer")
pima.label <- read.xls(file="pima-arbre-spad.xls",colNames=T,sheet="etiquette")

#induction of the decision tree using the rpart library
library(rpart)
tree.unpruned <- rpart(diabete ~ ., data = pima.train)
#specifying the right size of the tree by post-pruning
plotcp(tree.unpruned)
tree.pruned <- prune(tree.unpruned,cp=0.04)
#printing the decision tree
print(tree.pruned)

#applying the tree on the unlabeled dataset
prediction <- predict(tree.pruned,newdata = pima.unlabeled,type="class")

#comparing the prediction and the observed label
conf.matrix <- table(pima.label$diabete,prediction)
print(conf.matrix)

#computing the error rate
error.rate <- 1.0 - (conf.matrix[1,1]+conf.matrix[2,2])/sum(conf.matrix)
print(error.rate)

